"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const minimist_1 = __importDefault(require("minimist"));
const utils_1 = require("../utils/utils");
const base_1 = __importDefault(require("../models/base"));
class Cli extends base_1.default {
    run(environment) {
        return Promise.resolve()
            .then(() => {
            let args = minimist_1.default(environment.args);
            let RegisteredCommand = utils_1.findCommand(environment.commands, args._[0]);
            let command = new RegisteredCommand({
                ui: this.ui,
                project: this.project,
            });
            return command.validateAndRun(environment.args);
        })
            .catch(this.error.bind(this));
    }
    error(error) {
        this.ui.error(error);
        return 0;
    }
}
exports.default = Cli;
