"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const command_1 = __importDefault(require("../models/command"));
class Create extends command_1.default {
    constructor() {
        super(...arguments);
        this.defaultComponent = {
            component: path.resolve(__dirname, '..', 'generator'),
            command: 'app',
            prefix: 'plat-generator-'
        };
    }
    generalHelp(command) {
        let baseCommand = this.buildFullCommand().join(' ');
        this.ui.help(`
  General Usage:

    ${baseCommand} <component> [...options]`);
    }
    commandsHelp(command) {
        let baseCommand = this.buildFullCommand().join(' ');
        return this.env.listCommands(this.defaultComponent, this.commands[0]).then((commands) => {
            this.ui.help(`
  Commands:`);
            commands.forEach((c) => {
                this.ui.help(`    ${baseCommand} ${c} -h`);
            });
        });
    }
    run() {
        return this.env.command(this.defaultComponent, this.commands[0], this)
            .then(generator => generator.validateAndRun(this.args));
    }
}
Create.commandName = 'create';
Create.aliases = ['c'];
exports.default = Create;
