"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = __importDefault(require("./base"));
class ControlGenerator extends base_1.default {
    constructor(options, config) {
        super(options, config);
        this.noLessOrHtml = !!config.noLessOrHtml;
    }
    defineOptions() {
        super.defineOptions();
        if (!this.noLessOrHtml) {
            this.option('less', {
                description: `Do not generate a less file`,
                defaults: true,
            });
            this.option('html', {
                description: `Do not generate an html file`,
                defaults: true,
            });
        }
    }
    _render(src, dest, config) {
        let options = this.options;
        config.html = options.html;
        let promises = [this._renderFile('.ts', src, dest, config)];
        if (!this.noLessOrHtml) {
            if (options.less) {
                promises.push(this._renderFile('.less', this.ext, dest, config));
            }
            if (options.html) {
                promises.push(this._renderFile('.html', this.ext, dest, config));
            }
        }
        return Promise.all(promises);
    }
    _renderFile(ext, src, dest, config) {
        return this.render(src + ext, dest + ext, config);
    }
}
exports.default = ControlGenerator;
