"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const control_1 = __importDefault(require("../_models/control"));
class ViewControlGenerator extends control_1.default {
    constructor(options) {
        super(options, {
            type: 'ViewControl',
            ext: 'vc',
            allowExtends: true
        });
    }
    defineOptions() {
        super.defineOptions();
        this.option('router', {
            aliases: ['r'],
            description: `Inject a router to define child routes`,
            defaults: false
        });
    }
    _renderFile(ext, src, dest, config) {
        if (this.options.router && (ext === '.ts' || ext === '.html')) {
            src = 'routing.' + src;
        }
        return super._renderFile(ext, src, dest, config);
    }
}
exports.default = ViewControlGenerator;
ViewControlGenerator.aliases = ['vc'];
