"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Generator = exports.Command = void 0;
const ui_1 = __importDefault(require("./ui/ui"));
const cli_1 = __importDefault(require("./cli/cli"));
const project_1 = __importDefault(require("./models/project"));
const lodash_1 = __importDefault(require("lodash"));
var command_1 = require("./models/command");
Object.defineProperty(exports, "Command", { enumerable: true, get: function () { return __importDefault(command_1).default; } });
var generator_1 = require("./models/generator");
Object.defineProperty(exports, "Generator", { enumerable: true, get: function () { return __importDefault(generator_1).default; } });
let commands = require('require-all')({
    dirname: __dirname + '/commands',
    filter: /^((?!invalid).*)\.js$/,
});
function getLogLevel(args) {
    let index = args.indexOf('--loglevel');
    if (index > -1) {
        return args[index + 1];
    }
    else if (args.indexOf('--verbose') > -1) {
        return ui_1.default.LOG_LEVEL.TRACE;
    }
    else if (args.indexOf('--silent') > -1) {
        return ui_1.default.LOG_LEVEL.WARN;
    }
}
function default_1(options) {
    let logLevel = getLogLevel(options.args) || ui_1.default.LOG_LEVEL.INFO;
    if (lodash_1.default.isString(logLevel)) {
        logLevel = logLevel.toUpperCase();
    }
    let ui = new ui_1.default(lodash_1.default.extend({
        logLevel: logLevel,
    }, options)), environment = {
        commands: commands,
        args: options.args,
    };
    return project_1.default.project(ui, process.cwd())
        .then((project) => {
        return new cli_1.default({
            ui: ui,
            project: project,
        }).run(environment);
    })
        .then(undefined, ui.error.bind(ui));
}
exports.default = default_1;
