"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
const base_1 = __importDefault(require("./base"));
class ProcessUtils extends base_1.default {
    exec(command, args = [], options) {
        return new Promise((resolve, reject) => {
            let cmd = [command].concat(args).join(' ');
            this.ui.info(`Running command \`${cmd}\``);
            let child = child_process_1.exec(cmd, options);
            child.stdout.on('data', (data) => {
                this.ui.log(data, this.ui.LOG_LEVEL.INFO);
            });
            child.stderr.on('data', (data) => {
                this.ui.error(data);
            });
            child.on('close', (code) => {
                this.ui.debug(`${command} exited with code ${code}`);
                resolve(undefined);
            });
        });
    }
}
exports.default = ProcessUtils;
