"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAbsolute = exports.wrap = exports.pluralize = exports.findCommand = void 0;
const path = __importStar(require("path"));
const lodash_1 = require("lodash");
const os_1 = require("os");
const invalid_1 = __importDefault(require("../commands/invalid"));
function findCommand(commands, name) {
    let command = lodash_1.find(commands, (command) => {
        if (lodash_1.isFunction(command.default)) {
            command = command.default;
        }
        return command.commandName === name || command.aliases.indexOf(name) > -1;
    });
    if (lodash_1.isObject(command) && lodash_1.isFunction(command.default)) {
        command = command.default;
    }
    else if (!lodash_1.isFunction(command)) {
        command = invalid_1.default;
    }
    return command;
}
exports.findCommand = findCommand;
function pluralize(str) {
    let last = str.slice(-2);
    if (last[1] === 'y') {
        return str.slice(0, -1) + 'ies';
    }
    else if (/(?:.[s|z|x]|ch|sh)$/.test(last)) {
        return str + 'es';
    }
    return str + 's';
}
exports.pluralize = pluralize;
function wrap(str, width = 60, brk = os_1.EOL, cut = false) {
    if (!lodash_1.isString(str)) {
        return str;
    }
    let regex = '.{1,' + width + '}(\\s|$)' + (cut ? '|.{' + width + '}|.+$' : '|\\S+?(\\s|$)'), match = str.match(new RegExp(regex, 'g'));
    if (match.length > 1) {
        return match.join(brk) + os_1.EOL;
    }
    return match.join(brk);
}
exports.wrap = wrap;
function isAbsolute(srcPath) {
    if (!lodash_1.isString(srcPath)) {
        return false;
    }
    return path.resolve(srcPath) === path.normalize(srcPath);
}
exports.isAbsolute = isAbsolute;
