"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const chai_1 = require("chai");
const sinon_1 = require("sinon");
const generator_1 = __importDefault(require("../../../src/models/generator"));
const ui_mock_1 = __importDefault(require("../mock/ui.mock"));
chai_1.use(require('chai-as-promised'));
chai_1.use(require('sinon-chai'));
class MockGenerator extends generator_1.default {
    srcRoot(source) {
        return super.srcRoot(source);
    }
    destRoot(source) {
        return super.destRoot(source);
    }
    render(source, dest, context) {
        return super.render(source, dest, context);
    }
    mkdirDest(...dirs) {
        return super.mkdirDest.apply(this, dirs);
    }
}
describe('Generators', () => {
    let command;
    beforeEach(() => {
        command = new MockGenerator({
            ui: new ui_mock_1.default(),
            env: undefined,
            directory: '.',
            project: {
                root: '.',
                version: '1.0.0',
                bin: 'plat',
            },
        });
    });
    it('should set default paths for srcRoot', () => {
        chai_1.expect(command.srcRoot()).to.equal(path.resolve('.', 'templates'));
    });
    it('should set default paths for destRoot', () => {
        chai_1.expect(command.destRoot()).to.equal(path.resolve('.'));
    });
    it('should make a directory using destRoot when use mkdirDest', () => {
        let mkdir = sinon_1.stub(command.file, 'mkdir').callsFake(() => { });
        command.mkdirDest('foo', 'bar');
        chai_1.expect(mkdir).to.have.been.calledWith(path.resolve(command.destRoot(), 'foo'), path.resolve(command.destRoot(), 'bar'));
    });
});
